// Curso de Graficacin. Jack HV. 1998.
// Rutinas basicas de despligue. Lenguaje C. (Borland C++)

#include <dos.h>
#include <mem.h>
#include <conio.h>
#include <stdlib.h>
#include <stdio.h>
#include <alloc.h>
#include <math.h>

#define VGA256 0x13
#define VGASEG 0xA000
#define TEXT   0x03

typedef unsigned char uchar;

typedef struct RGB{
  char r,g,b;
};

typedef struct point3D{
  float x,y,z;
};

typedef float Arr9 [9][2];



float sintab[360], costab[360];

uchar far *vga_mem;
uchar far *vScr;

RGB paleta[256];

int Xoff=160, Yoff=100, Zoff=1;

void setLookUpTabs() {
  float deg=0;
  for(int i=0;i<360;i++) {
	sintab[i]=sin(deg);
	costab[i]=cos(deg);
	deg+=0.017;
  }
}

//-----------------------------------------------------

// dibuja un pixel directamente en la memoria.
void memPutPixel (int x, int y, uchar Col, uchar far *buffer) {
  memset(buffer+x+(y*320),Col,1);
}

// Optimizado utilizando desplazamientos en vez de la multiplicacion
void memPixelOpt (int x, int y, char color, unsigned vseg){
  pokeb(vseg, (y << 8) + (y << 6) + x, color);
}

// esta es una rutina optimizada (pero no lo suficiente)
void asmDot(int x, int y, char c) {
  asm {
//                                            8088 286 386 486
	mov     ax, 0xA000            //        8   5   4   1
	mov     es,ax                 //        2   2   2   3
	mov     bx,[x]                //	8   5   4   1
	mov     dx,[y]                //	8   5   4   1
	push    bx                    //       15   3   2   1
	mov     bx, dx                //	2   2   2   1
	mov     dh, dl                //	2   2   2   1
	xor     dl, dl                //	3   2   2   1
	shl     bx, 6                 //	8  11   3   2
	add     dx, bx                //	3   2   2   1
	pop     bx                    //       12   5   4   4
	add     bx, dx                //	3   2   2   1
	mov     di, bx                //	2   2   2   3
	mov     al, [c]               //	8   5   4   1
	stosb                         //       11   3   4   5
  }
}

// Este es el que hicimos en clase (la ms rpida!)
void asmPixel(int x, int y, char c) {
  asm {
	mov ax, 0xA000             
	mov es,ax
	mov ax,[y]                
	mov dx,ax
	shl ax,8
	shl dx,6
	add ax,dx
	add ax,[x]
	mov di,ax
	xor ax,ax
	mov ah,[c]
	mov es:[di],ah
  }
}

void asmXorPixel(int x, int y, char c) {
  asm {
	mov ax, 0xA000
	mov es,ax
	mov ax,[y]
	mov dx,ax
	shl ax,8
	shl dx,6
	add ax,dx
	add ax,[x]
	mov di,ax
	xor ax,ax
	mov ah,[c]
	xor es:[di],ah
  }
}

// dibuja un pixel por medio de la Int 10h servicio 0Ch
void intPutpixel (int x, int y, char Col) {
    _AL = Col;
    _AH = 0x0C;
    _CX = y;
    _DX = x;
	geninterrupt (0x10);
}

//-----------------------------------------------

void plot3D (point3D p, char color){
   int nx,ny;
   // (xoff, yoff) = (x,y) del objeto
   // zoff es que tan lejos esta el objeto. Xoff y Yoff establecen el centro.
   // 256 es el valor de la perpectiva, modificarlo produce efectos raros
       nx =  ((256*p.x) / (p.z-Zoff)) + Xoff;
       ny =  ((256*p.y) / (p.z-Zoff)) + Yoff;
	   asmPixel(nx,ny,color);
}


//-----------------------------------------------

int sgn(float a){

  if (a>0) return +1;
  if (a<0) return -1;
  if (a==0) return 0;
  return 0;
}
void DDAline256(int xi,int yi,int xf,int yf, char color){
   float dx,dy,er,x,y;
   int j;

	if ((xf>319) | (yf>199) | (xi>319) | (yi>199))
		return;
	else{
		 dx=(xf-xi);
		 dy=(yf-yi);
		 if (abs(dx)>=abs(dy))
			 er=1/fabs(dx+0.001);
		 else
			 er=1/fabs(dy+0.001);
		 dx=dx*er;    dy=dy*er;
		 x=xi;        y=yi;
		 er=1/er;
		 j=1;
		 while (j<=er) {
			  asmPixel(x,y,color);
			  //memPixelOpt(x,y,color,VGASEG);
			  x=x+dx;
			  y=y+dy;  j=j+1;
		  }
	  }

}

void DDAXorline256(int xi,int yi,int xf,int yf, char color){
   float dx,dy,er,x,y;
   int j;

	if ((xf>319) | (yf>199) | (xi>319) | (yi>199))
		return;
	else{
		 dx=(xf-xi);
		 dy=(yf-yi);
		 if (abs(dx)>=abs(dy))
			 er=1/fabs(dx+0.001);
		 else
			 er=1/fabs(dy+0.001);
		 dx=dx*er;    dy=dy*er;
		 x=xi;        y=yi;
		 er=1/er;
		 j=1;
		 while (j<=er) {
			  asmXorPixel(x,y,color);
			  //memPixelOpt(x,y,color,VGASEG);
			  x=x+dx;
			  y=y+dy;  j=j+1;
		  }
	  }
}
//-----------------------------------------------

// Cambia d*e color un bloque de memoria <=64 kb
void memScrColor(uchar Col, int Size, uchar *buffer) {
  memset(buffer,Col,Size);
}

void memCls (uchar *buffer){  // limpia la pantalla
  memset(buffer,0,64000);
}

void SetVideoMode(int mode) {
	 _AL = mode;
	 _AH = 0;
	 geninterrupt (0x10);
}

//------------------------------------------------

float RX(float rxi,float ryi,float rxf,float ryf,float A) {
  A=(A*0.01747)* -1;
  return (((rxf-rxi)*cos(A))-((ryf-ryi)*sin(A))+rxi);
}

float RY(float rxi,float ryi,float rxf,float ryf,float A) {
  A=(A*0.01747)* -1;
  return (((ryf-ryi)*cos(A))+((rxf-rxi)*sin(A))+ryi);
}


void pinta (uchar *buffer){
  for (int i=0; i<256; i++){
	memScrColor(i,i*200, buffer);
	delay(10);
  }
}

void pintaScr(uchar *pbuffer) {
  for (int i=0; i<256; i++){
	memScrColor(i,64000,pbuffer);
	delay(10);
  }
}

void polRegular(int lados, int lado, float x, float y, uchar c) {
  float theta=2*M_PI/lados;
  float x2,y2;
  for(int i=0;i<lados;i++) {
	x2=x+lado*cos(i*theta);
	y2=y+lado*sin(i*theta);
	DDAline256(x,y,x2,y2,c);
	x=x2;
	y=y2;
  }
}


void polRegularRot(int lados, int lado, float x, float y, uchar c,float cx,float cy,float th) {
  float theta=2*M_PI/lados;
  float x2,y2;
  for(int i=0;i<lados;i++) {
	x2=x+lado*cos(i*theta);
	y2=y+lado*sin(i*theta);
	DDAline256(RX(x,y,cx,cy,th),RY(x,y,cx,cy,th),RX(x2,y2,cx,cy,th),RY(x2,y2,cx,cy,th),c);
	x=x2;
	y=y2;
  }
}


void ArrPRR(int lados,int lado, float x, float y, float cx,float cy,float th, Arr9 &a) {
  float theta=2*M_PI/lados;
  float x2,y2;
  for(int i=0;i<9;i++) {
	x2=x+lado*cos(i*theta);
	y2=y+lado*sin(i*theta);
	a[i][0]=RX(x2,y2,cx,cy,th);
	a[i][1]=RY(x2,y2,cx,cy,th);
	x=x2;
	y=y2;
  }
}

void ArrPR(int lados,int lado, float x, float y,  Arr9 &a) {
  float theta=2*M_PI/lados;
  float x2,y2;
  for(int i=0;i<9;i++) {
	a[i][0]=x2=x+lado*cos(i*theta);
	a[i][1]=y2=y+lado*sin(i*theta);
	x=x2;
	y=y2;
  }
}

void MorphPoint(float x1,float y1,float x2,float y2,float &xi,float &yi, int sc, int i){
  xi=x1+(((x2-x1)*i)/sc);
  yi=y1+(((y2-y1)*i)/sc);
}


void PIR(Arr9 aIrr,uchar c){
  for (int i=0; i<9; i++)
	DDAline256(aIrr[i][0],aIrr[i][1],aIrr[i+1][0],aIrr[i+1][1],c);
//  DDAline256(aIrr[0][0],aIrr[0][1],aIrr[9][0],aIrr[9][1],c);

}

void PIRXor(Arr9 aIrr,uchar c){
  for (int i=0; i<9; i++)
	DDAXorline256(aIrr[i][0],aIrr[i][1],aIrr[i+1][0],aIrr[i+1][1],c);
//  DDAXorline256(aIrr[0][0],aIrr[0][1],aIrr[9][0],aIrr[9][1],c);

}


//*************
typedef struct Pto2d {
  float x,y;
};

void polIrregular(int nlados,float x, float y, uchar c) {
  Pto2d aIrr[100];
  float x1,y1;
  int i;

  aIrr[0].x = x;
  aIrr[0].y = y;
  for (i=1;i<nlados;i++) {
	aIrr[i].x = random(320);
	aIrr[i].y = random(200);
  }

  for (i=0; i<nlados-1; i++)
	DDAline256(aIrr[i].x,aIrr[i].y,aIrr[i+1].x,aIrr[i+1].y,c);
  DDAline256(aIrr[0].x,aIrr[0].y,aIrr[nlados-1].x,aIrr[nlados-1].y,c);
}


float escala (float d, float sc){
  return d*sc;
}

float trasx(float x, float xt){
  return x+xt;
}

float trasy(float y, float yt){
  return y+yt;
}


void main()
{
  SetVideoMode(VGA256);
  setLookUpTabs();
  randomize();
  // Se reserva la memoria para el buffer
  //(si solo se maneja una pag. de mem. esto no es necesario)
  // y luego se direcciona al segmento de video.

 // if (!(vScr=(uchar far*) farmalloc(64000L))){
 //	exit(1);
 // }
  vga_mem=(uchar far*) MK_FP(VGASEG, 0);

Arr9 arr,arr2,arr3;
int pasos=10;

for (int j=3;j<9;j++){
//  polRegular(j,escala(50,0.5),100,50,j);
/*  DDAline256(0,0,100,100,j);
  delay(200);
  DDAXorline256(0,0,100,100,j);
*/
/*  ArrPRR(j,escala(50,0.5),trasx(100,20),trasy(50,15),100,50,45,arr);
  ArrPRR(j+1,escala(50,0.5),trasx(100,20),trasy(50,15),100,50,45,arr2);
  */
  ArrPR(j,50,100,50,arr);
  ArrPR(j+1,50,100,50,arr2);


  for (int k=0;k<pasos;k++){
//	asmPixel (arr[k][0],arr[k][1],k);
//	asmPixel (arr2[k][0],arr2[k][1],k);

	for (int l=0;l<9;l++)
	  MorphPoint(arr[l][0],arr[l][1],arr2[l][0],arr2[l][1],arr3[l][0],arr3[l][1],pasos,k);

//	asmPixel (arr3[k][0],arr3[k][1],k);

	PIR(arr3,9);
	delay(100);
	PIRXor(arr3,9);

  }

}
//pintaScr(vga_mem);
  //polIrregular(13,50,50,j);
getch();


  memCls(vga_mem);
  SetVideoMode(TEXT);
  farfree(vScr);
}