//Simple example using Multidimensional Logic
//Carlos Gershenson
//1998
//e-mail: carlos@jlagunez.iquimica.unam.mx

#include <stdio.h>
#include <math.h>
#include <conio.h>
#include <iostream.h>

class mdlv {
  public:
    float x,y;//x=oldness, y= youthness
    mdlv(){x=0;y=0;}
};

const n=5;
mdlv a[n];
int i=0,j=0;
const float inc = 0.25;

void compare(float &x,float &y, int old){
  char ch=0;
  if (old)
    cout<<"Is "<<i<<" older than "<<j<<"? (y/n)\n";
  else
    cout<<"Is "<<j<<" younger than "<<i<<"? (y/n)\n";
  while((ch!='y')&&(ch!='n'))
    ch=getch();
  if (ch=='y')
    x+=inc;
  if (ch=='n')
    y+=inc;
}

float mdlproj(float x, float y){//multidimensional projection in fuzzy logic
				//returns projection of oldness
				//proj of youthness would be (1-proj of oldness)
  return ((x-y+1)/2);
}

void main(){
  clrscr();
  cout<<"Simple example using Multidimensional Logic\n"
      <<"Carlos Gershenson\n\n";
  for (i=0;i<n;i++)
    for (j=0;j<n;j++){
      if (i<j)
	compare(a[i].x,a[j].x,1);
      if (i>j)
	compare(a[j].y,a[i].y,0);
    }
  cout<<"__________________________________________________________________________\n"
      <<"Number   Linear Old   Linear Young   Multidimensional   Projection (old)\n"
      <<"__________________________________________________________________________\n" ;
  for (i=0;i<n;i++)
    cout<<i<<"         "<<a[i].x<<"             "<<a[i].y<<"             ("
    <<a[i].x<<","<<a[i].y<<")             "<<mdlproj(a[i].x,a[i].y)<<"\n";
  cout<<"__________________________________________________________________________\n"
      <<"Press any key to finish...\n";
  getch();
}