// Curso de Graficacin. Jack HV. 1998.
// Rutinas basicas de despligue. Lenguaje C. (Borland C++)

#include <dos.h>
#include <mem.h>
#include <conio.h>
#include <stdlib.h>
#include <stdio.h>
#include <alloc.h>
#include <math.h>

#define VGA256 0x13
#define VGASEG 0xA000
#define TEXT   0x03

typedef unsigned char uchar;

typedef struct RGB{
  char r,g,b;
};

typedef struct point3D{
  float x,y,z;
};

float sintab[360], costab[360];

uchar far *vga_mem;
uchar far *vScr;

RGB paleta[256];

int Xoff=160, Yoff=100, Zoff=1;

void setLookUpTabs() {
  float deg=0;
  for(int i=0;i<360;i++) {
	sintab[i]=sin(deg);
	costab[i]=cos(deg);
	deg+=0.017;
  }
}

//-----------------------------------------------------

// dibuja un pixel directamente en la memoria.
void memPutPixel (int x, int y, uchar Col, uchar far *buffer) {
  memset(buffer+x+(y*320),Col,1);
}

// Optimizado utilizando desplazamientos en vez de la multiplicacion
void memPixelOpt (int x, int y, char color, unsigned vseg){
  pokeb(vseg, (y << 8) + (y << 6) + x, color);
}

// esta es una rutina optimizada (pero no lo suficiente)
void asmDot(int x, int y, char c) {
  asm {
//                                            8088 286 386 486
	mov     ax, 0xA000            //        8   5   4   1
	mov     es,ax                 //        2   2   2   3
	mov     bx,[x]                //	8   5   4   1
	mov     dx,[y]                //	8   5   4   1
	push    bx                    //       15   3   2   1
	mov     bx, dx                //	2   2   2   1
	mov     dh, dl                //	2   2   2   1
	xor     dl, dl                //	3   2   2   1
	shl     bx, 6                 //	8  11   3   2
	add     dx, bx                //	3   2   2   1
	pop     bx                    //       12   5   4   4
	add     bx, dx                //	3   2   2   1
	mov     di, bx                //	2   2   2   3
	mov     al, [c]               //	8   5   4   1
	stosb                         //       11   3   4   5
  }
}

// Este es el que hicimos en clase (la ms rpida!)
void asmPixel(int x, int y, char c) {
  asm {
	mov ax, 0xA000             
	mov es,ax
	mov ax,[y]                
	mov dx,ax
	shl ax,8
	shl dx,6
	add ax,dx
	add ax,[x]
	mov di,ax
	xor ax,ax
	mov ah,[c]
	mov es:[di],ah
  }
}

// dibuja un pixel por medio de la Int 10h servicio 0Ch
void intPutpixel (int x, int y, char Col) {
    _AL = Col;
    _AH = 0x0C;
    _CX = y;
    _DX = x;
	geninterrupt (0x10);
}

//-----------------------------------------------

void plot3D (point3D p, char color){
   int nx,ny;
   // (xoff, yoff) = (x,y) del objeto
   // zoff es que tan lejos esta el objeto. Xoff y Yoff establecen el centro.
   // 256 es el valor de la perpectiva, modificarlo produce efectos raros
       nx =  ((256*p.x) / (p.z-Zoff)) + Xoff;
       ny =  ((256*p.y) / (p.z-Zoff)) + Yoff;
       asmPixel(nx,ny,color);
}


//-----------------------------------------------

int sgn(float a){

  if (a>0) return +1;
  if (a<0) return -1;
  if (a==0) return 0;
  return 0;
}

void line256(int a, int b,int c,int d,char col){
   float u,s,v,d1x,d1y,d2x,d2y,m,n;
   int i;
   // primero se calcula la longitud de la recta en x y y
   u = c - a;
   v = d - b;
   d1x = sgn(u);
   d1y = sgn(v);
   d2x = sgn(u);
   d2y = 0;
   m = abs(u);
   n = abs(v);
   if ((m<=n)){
	   d2x = 0 ;
	   d2y = sgn(v);
	   m   = abs(v);
	   n   = abs(u);
	}
   s = (int) (m/2);
   for (i=0;i<floor(m);i++) {
		 asmPixel(a,b,col);
         s += n;
         if (s >= m) {
           s -= m;
           a += d1x;
           b += d1y;
		 }
		 else {
		   a += d2x;
           b += d2y;
		 }
   }
}

void DDAline256(int xi,int yi,int xf,int yf, char color){
   float dx,dy,er,x,y;
   int j;

	if ((xf>319) | (yf>199) | (xi>319) | (yi>199))
		return;
	else{
		 dx=(xf-xi);
		 dy=(yf-yi);
		 if (abs(dx)>=abs(dy))
			 er=1/fabs(dx+0.001);
		 else
			 er=1/fabs(dy+0.001);
		 dx=dx*er;    dy=dy*er;
		 x=xi;        y=yi;
		 er=1/er;
		 j=1;
		 while (j<=er) {
			  asmPixel(x,y,color);
			  //memPixelOpt(x,y,color,VGASEG);
			  x=x+dx;
			  y=y+dy;  j=j+1;
		  }
	  }
}

void circle256(int cx, int cy, int radio, int color) {
	 float deg = 0;
	 int x,y;
		do {
		   x = floorl(radio * cos(deg));
		   y = floorl(radio * sin(deg));
		   asmPixel (x+cx+160, y+cy+100, color);
		   deg += 0.005;
		} while (deg <= 6.4);
}

void fastcircle256(int cx, int cy, int radio, int color) {
	 int deg = 0, x,y;
		do {
		   x = floorl(radio * costab[deg]);
		   y = floorl(radio * sintab[deg]);
		   asmPixel (x+cx+160, y+cy+100, color);
		   deg += 1;
		} while (deg <= 360);
}


//-----------------------------------------------

void set256palette(char nreg,char r, char g, char b){
  _AH = 0x10;
  _AL = 0x10;      // cambia reg. indiv.
  _BX = nreg;      // numero de reg.
  _CH = g;         // green level
  _CL = b;         // blue  level
  _DH = r;         // red   level
  geninterrupt (0x10);
}

void setPortPalette (uchar index,char r, char g, char b){

	outp(0x03c8, index);
	outp(0x03c9, r);
	outp(0x03c9, g);
	outp(0x03c9, b);
}

RGB get256palette(uchar nreg){
   RGB color;

  _AH = 0x10;
  _AL = 0x15;           // lee reg. indiv.
  _BL = nreg;           // numero de reg. 
  geninterrupt (0x10);
  color.r =_DH;               // red level
  color.g =_CH;               // green level
  color.b =_CL;               // blue level
  return color;
}

void getpalette(){
  for (int i=0; i<256; i++){
	paleta[i] = get256palette(i);
  }
}

void gray_tones() {
  int i,gris;

   for (i=0;i<256;i++){
		gris= (paleta[i].b*0.59)+(paleta[i].g*0.21)+(paleta[i].r*0.20);
	  //	set256palette (i,gris,gris,gris);
		setPortPalette(i,gris,gris,gris);
		paleta[i].r = gris;
		paleta[i].g = gris;
		paleta[i].b = gris;
	 }
}

void G_tones(float bb,float gg,float rr) {
  int i,gris;
  for (i=0;i<256;i++){
		gris= (paleta[i].b*bb)+(paleta[i].g*gg)+(paleta[i].r*rr);
	  //	set256palette (i,gris,gris,gris);
		setPortPalette(i,gris,gris,gris);
		paleta[i].r = gris;
		paleta[i].g = gris;
		paleta[i].b = gris;
	 }
}


void RGB_tones() {
  int i;

	 for (i=0;i<64;i++){
		//set256palette (i,i,0,0);
		setPortPalette(i,i,0,0);
		paleta[i].r = i;
		paleta[i].g = 0;
		paleta[i].b = 0;
	 }
	 for (i=64;i<128;i++){
		//set256palette (i,0,i-64,0);
		setPortPalette(i,0,i-64,0);
		paleta[i].r = 0;
		paleta[i].g = i-64;
		paleta[i].b = 0;
	 }
	 for (i=128;i<192;i++){
		//set256palette (i,0,0,i-128);
		setPortPalette(i,0,0,i-128);
		paleta[i].r = 0;
		paleta[i].g = 0;
		paleta[i].b = i-128;
	 }
	 for (i=192;i<256;i++){
		//set256palette (i,i-192,i-190,i-188);
		setPortPalette(i,i-192,i-190,i-180);
		paleta[i].r = i-192;
		paleta[i].g = i-190;
		paleta[i].b = i-188;
	 }
}

void R_tones(float bb,float gg,float rr) {
  int i;

	 for (i=0;i<64;i++){
		//set256palette (i,i,0,0);
		setPortPalette(i,i*rr,0,0);
		paleta[i].r = i*rr;
		paleta[i].g = 0;
		paleta[i].b = 0;
	 }
	 for (i=64;i<128;i++){
		//set256palette (i,0,i-64,0);
		setPortPalette(i,0,i*gg,0);
		paleta[i].r = (i-64);
		paleta[i].g = (i-64)*gg;
		paleta[i].b = (i-64);
	 }
	 for (i=128;i<192;i++){
		//set256palette (i,0,0,i-128);
		setPortPalette(i,i-128,i-128,(i-128)*bb);
		paleta[i].r = (i-128);
		paleta[i].g = (i-128);
		paleta[i].b = (i-128)*bb;
	 }
	 for (i=192;i<256;i++){
		//set256palette (i,i-192,i-190,i-188);
		setPortPalette(i,i-192,i-190,i-180);
		paleta[i].r = i-192;
		paleta[i].g = i-190;
		paleta[i].b = i-188;
	 }
}


// Cambia d*e color un bloque de memoria <=64 kb
void memScrColor(uchar Col, int Size, uchar *buffer) {
  memset(buffer,Col,Size);
}

void memCls (uchar *buffer){  // limpia la pantalla
  memset(buffer,0,64000);
}

void SetVideoMode(int mode) {
	 _AL = mode;
	 _AH = 0;
	 geninterrupt (0x10);
}

//------------------------------------------------

void pinta (uchar *buffer){
  for (int i=0; i<256; i++){
	memScrColor(i,i*200, buffer);
	delay(10);
  }
}

void pintaScr(uchar *pbuffer) {
  for (int i=0; i<256; i++){
	memScrColor(i,64000,pbuffer);
	delay(10);
  }
}

void polRegular(int lados, int lado, float x, float y, uchar c) {
  float theta=2*M_PI/lados;
  float x2,y2;
  for(int i=0;i<lados;i++) {
	x2=x+lado*cos(i*theta);
	y2=y+lado*sin(i*theta);
	DDAline256(x,y,x2,y2,c);
	x=x2;
	y=y2;
  }
}

//*************
typedef struct Pto2d {
  float x,y;
};

void polIrregular(int nlados,float x, float y, uchar c) {
  Pto2d aIrr[100];
  float x1,y1;
  int i;

  aIrr[0].x = x;
  aIrr[0].y = y;
  for (i=1;i<nlados;i++) {
	aIrr[i].x = random(320);
	aIrr[i].y = random(200);
  }

  for (i=0; i<nlados-1; i++)
	DDAline256(aIrr[i].x,aIrr[i].y,aIrr[i+1].x,aIrr[i+1].y,c);
  DDAline256(aIrr[0].x,aIrr[0].y,aIrr[nlados-1].x,aIrr[nlados-1].y,c);
}

void main()
{
  SetVideoMode(VGA256);
  setLookUpTabs();
  randomize();
  // Se reserva la memoria para el buffer
  //(si solo se maneja una pag. de mem. esto no es necesario)
  // y luego se direcciona al segmento de video.

  vScr   =(uchar far*) farmalloc(64000L);
  vga_mem=(uchar far*) MK_FP(VGASEG, 0);

/*  for(int i=1; i<200; i++){
	intPutpixel (i,i,i);
	asmDot      (i,i+10,i);
	asmPixel    (i,i+20,i);
	memPutPixel (i,i+30,i, vga_mem);
	memPixelOpt (i,i+40,i, VGASEG);
	}
  getch();

  memCls(vga_mem);
  memCls(vScr);
  for(i=1; i<200; i++)
	memPutPixel (i,i+30,i, vScr);

  fastcircle256(0,0,40,50);
  getch();
  _fmemcpy(vga_mem,vScr,64000);
  getch();*/

//--------------------------------
 //getpalette();

// R_tones(.1,.1,.1);

 //for (int i=0;i<256;i++)
//   setPortPalette(i,i,i,i);
//  G_tones(0,0,.5);
//  pintaScr(vga_mem);
//  getch();
for (int j=1;j<10;j++)
//  polRegular(j,50,100,50,j);
//pintaScr(vga_mem);
  polIrregular(1.5,50,50,j);
getch();

/*  RGB_tones();
  pintaScr(vga_mem);
  getch();

  gray_tones();
  pintaScr(vga_mem);
  getch();

  memCls(vga_mem);
  RGB_tones();
*/
//-------------------------------
/*  randomize();
  for (i=0;i<50;i++)
	line256(random(320),random(200),random(320),random(200),i);

  for(i=0;i<25;i++)
	circle256(i,i,i,i);

  for(i=0;i<25;i++)
	fastcircle256(i,i,i,i+30);

  getch();
*/

  memCls(vga_mem);
  SetVideoMode(TEXT);
  farfree(vScr);
}