{$B-}
Program Patoarbol;{v 4.0}                       {Carlos Gershenson}

Uses
	crt,auxbtree;
Const
        maxkeys=4;
        maxchild=5;
        maxwkeys=5;
        maxwchild=6;
        nokey='';
        no=false;
        yes=true;
        null=-1;


Type
        reg=record
          key:string;
          pos:longint;
          bor:boolean;
        end;
        BTPage=record
          keycount:integer;
          r:array[1..maxkeys] of reg;
          child:array[1..maxchild] of integer;
        end;
Var

	btfd:file of BTPage;
        promoted:boolean;
        root,promorrn,minkeys,pagesize:integer;
        promokey,key:reg;
        g:char;
        arch:string;

Function btopen:boolean;

begin
        assign(btfd,arch);
        If FileExists(arch) then
        begin
          Reset(btfd);
          btopen:=true;
        end
        else
          btopen:=false;
end;

Function compara(a,b:reg):boolean;

begin
        If (a.key=b.key)and(a.pos=b.pos)and(a.bor=b.bor) then
          compara:=true
        else
          compara:=false;
end;

Function getroot:integer;

var
        root:BTPage;

begin
        seek(btfd,0);
        if not eof (btfd) then
        begin
          read(btfd,root);
          getroot:=root.keycount;
        end
        else
          Writeln('Error: No se encontro la raiz');
end;

Function getpage:integer;

begin
        getpage:=filesize(btfd);
end;

Procedure pageinit(var ppage:BTPage);

var
        j:integer;

begin
        For j:=1 to maxkeys do
        begin
          ppage.r[j].key:=nokey;
          ppage.r[j].pos:=0;
          ppage.r[j].bor:=false;
          ppage.child[j]:=null;
        end;
        ppage.child[maxkeys+1]:=null;
end;

Procedure putroot(root:integer);

var
        rootrrn:BTPage;

begin
        seek(btfd,0);
        rootrrn.keycount:=root;
        pageinit(rootrrn);
        write(btfd,rootrrn);
end;

Procedure btread(rrn:integer;var pageptr:BTPage);
begin
        seek(btfd,rrn);
        read(btfd,pageptr);
end;

Procedure btwrite(rrn:integer; pageptr:BTPage);
begin
        seek(btfd,rrn);
        write(btfd,pageptr);
end;

Function createroot(key:reg;left,right:integer):integer;

var
        page:BTPage;
        rrn:integer;

begin
        rrn:=getpage;
        pageinit(page);
        page.r[1]:=key;
        page.child[1]:=left;
        page.child[2]:=right;
        page.keycount:=1;
        btwrite(rrn,page);
        putroot(rrn);
        createroot:=rrn;
end;

Function createtree:integer;

var
        rootrrn:integer;

begin
        rewrite(btfd);
        rootrrn:=getpage;
        putroot(rootrrn);
        createtree:=createroot(key,null,null);
end;

Function searchnode(key:reg;ppage:BTPage;var pos:integer):boolean;

var
        i:integer;

begin
        i:=1;
        while (i<=ppage.keycount)and(key.key>ppage.r[i].key)do
          i:=i+1;
        pos:=i;
        if (pos<=ppage.keycount)and(compara(key,ppage.r[pos]))then
          searchnode:=yes
        else
          searchnode:=no;
end;

Procedure insinpage(key:reg;rchild:integer;var ppage:BTPage);

var
        i:integer;

begin
        i:=ppage.keycount+1;
        while (key.key<ppage.r[i-1].key)and(i>1)do
        begin
          ppage.r[i]:=ppage.r[i-1];
          ppage.child[i+1]:=ppage.child[i];
          i:=i-1;
        end;
        ppage.keycount:=ppage.keycount+1;
        ppage.r[i]:=key;
        ppage.child[i+1]:=rchild;
end;

Procedure split(key:reg;rchild:integer;var poldpage:BTPage;var promokey:reg;
          var promorchild:integer;var pnewpage:BTPage);

var
        i:integer;
        workkeys:array[1..maxwkeys]of reg;
        workch:array[1..maxwchild]of integer;

begin
        for i:=1 to maxkeys do
        begin
          workkeys[i]:=poldpage.r[i];
          workch[i]:=poldpage.child[i];
        end;
        workch[maxkeys+1]:=poldpage.child[maxkeys+1];
        i:=maxkeys+1;
        While (key.key<workkeys[i-1].key)and(i>1) do
        begin
          workkeys[i]:=workkeys[i-1];
          workch[i+1]:=workch[i];
          i:=i-1;
        end;
        workkeys[i]:=key;
        workch[i+1]:=rchild;
        promorchild:=getpage;
        pageinit(pnewpage);
        for i:=1 to minkeys do
        begin
          poldpage.r[i]:=workkeys[i];
          poldpage.child[i]:=workch[i];
          pnewpage.r[i]:=workkeys[i+1+minkeys];
          pnewpage.child[i]:=workch[i+1+minkeys];
          poldpage.r[i+minkeys].key:=nokey;
          poldpage.child[i+1+minkeys]:=null;
        end;
        poldpage.child[1+minkeys]:=workch[minkeys+1];
        if odd(maxkeys) then
        begin
          pnewpage.r[minkeys+1]:=workkeys[maxwkeys];
          pnewpage.child[minkeys+2]:=workch[maxwchild];
          pnewpage.child[minkeys+1]:=workch[maxwchild-1];
        end
        else
        begin
          pnewpage.child[minkeys+1]:=workch[maxwchild];
          pnewpage.keycount:=maxkeys-minkeys;
          poldpage.keycount:=minkeys;
          promokey:=workkeys[minkeys+1];
        end;

end;


Function insert(rrn:integer;key:reg;var promorchild:integer;var promokey:reg):boolean;

Var
        page,newpage:BTPage;
        found,promoted:boolean;
        pos,pbrrn:integer;
        pbkey:reg;

Begin
     If rrn=null then
     begin
       promokey:=key;
       promorchild:=null;
       insert:=yes;
     end
     else
     begin
       btread(rrn,page);
       found:=searchnode(key,page,pos);

       {al comentar este tramo de codigo, se permiten laves repetidas}

       {if found then
       begin
         writeln('Error: la llave ya existe');
         insert:=no;
       end
       else
       }begin
         promoted:=insert(page.child[pos],key,pbrrn,pbkey);
         if not promoted then
           insert:=no
         else
         begin
           If (page.keycount<maxkeys)then
           begin
             insinpage(pbkey,pbrrn,page);
             btwrite(rrn,page);
             insert:=no;
           end
           else
           begin
             split(pbkey,pbrrn,page,promokey,promorchild,newpage);
             btwrite(rrn,page);
             btwrite(promorchild,newpage);
             insert:=yes;
           end;
         end;
       end;
     end;
end;

Procedure insertar;
var car:char;

begin
     clrscr;
     Writeln('Inserte... ');
     While Upcase(car)<>'N' do
     begin
       readln(key.key);
       promoted:=insert(root,key,promorrn,promokey);
       If promoted then
         root:=createroot(promokey,root,promorrn);
       Write('Otro? (S/N) ');
       car:=readkey;writeln(car);
     end;
     close(btfd);
end;

Procedure Buscar;

var
        key:string;
        bt:BTPage;
        found:boolean;

Procedure search(root:integer; b:BTPage);
var
        j,k:integer;
        leaf:boolean;

begin
     seek(btfd,root);
     read(btfd,b);
     leaf:=true;
     For j:=1 to maxkeys do
     begin
       If key = b.r[j].key then
       begin
         found:=true;
         Writeln('El dato esta en el registro ',root,', posicion ',j);
         If b.r[j].bor then
           writeln('La llave esta marcada para ser borrada');
       end;
       If (key <= b.r[j].key)and(b.child[j]<>-1) then
         search(b.child[j],b);
     end;
     If (key >= b.r[j].key)and(b.child[j+1]<>-1) then
       search(b.child[j+1],b);
end;

begin
     clrscr;
     found:=false;
     Write('Dame la cadena a buscar: ');
     readln(key);
     Reset(btfd);
     search(root,bt);
     If found=false then
       Writeln('No se encontro el dato');
     Writeln;
     Writeln('Presione cualquier tecla para continuar...');
     key:=readkey;
     close(btfd);

end;


Procedure Borrar(act:boolean);

var
        key:string;
        bt:BTPage;
        found:boolean;

Procedure search(root:integer; b:BTPage);
var
        j,k:integer;
        leaf:boolean;

begin
     seek(btfd,root);
     read(btfd,b);
     leaf:=true;
     For j:=1 to maxkeys do
     begin
       If (key = b.r[j].key)and (not found) then
       begin
         if b.r[j].bor <> act then
         begin
           found:=true;
           if act then
           begin
             b.r[j].bor:=true;
             Writeln('La llave "',b.r[j].key,'" ha sido borrada');
           end
           else
           begin
             b.r[j].bor:=false;
             Writeln('La llave "',b.r[j].key,'" ha sido desborrada');
           end;
           seek(btfd,root);
           write(btfd,b);
         end;
       end;
       If (key <= b.r[j].key)and(b.child[j]<>-1)and (not found) then
         search(b.child[j],b);
     end;
     If (key >= b.r[j].key)and(b.child[j+1]<>-1)and (not found) then
       search(b.child[j+1],b);
end;

begin
     clrscr;
     found:=false;
     If act then
       Write('Dame la cadena a borrar: ')
     else
       Write('Dame la cadena a desborrar: ');
     readln(key);
     Reset(btfd);
     search(root,bt);
     If found=false then
       Writeln('No se encontro el dato');
     Writeln;
     Writeln('Presione cualquier tecla para continuar...');
     key:=readkey;
     close(btfd);

end;


Procedure Mostrar(act:boolean);

var
        key:string;
        bt:BTPage;

Procedure search(root:integer; b:BTPage);
var
        j,k:integer;
        leaf:boolean;

begin
     seek(btfd,root);
     read(btfd,b);
     leaf:=true;
     For j:=1 to maxchild do
     begin
       If b.child[j]<>-1 then
       begin
         search(b.child[j],b);
         if j<> maxchild then
            If b.r[j].key=nokey then
             write(' ')
           else
             If b.r[j].bor <> act then
               write(b.r[j].key,' ');
         leaf:=false;
       end;
     end;
     If leaf then
         For k:=1 to maxkeys do
           If b.r[k].key=nokey then
             write(' ')
           else
             If b.r[k].bor <> act then
               write(b.r[k].key,' ');
end;

begin
     clrscr;
     Reset(btfd);
     search(root,bt);
     Writeln;
     Writeln('Presione cualquier tecla para continuar...');
     key:=readkey;
     close(btfd);

end;

Procedure Eliminar;

var
        btfd2:file of BTPage;
        fs,pos:longint;
        b:BTPage;
        i:integer;
        k:char;
        raiz:boolean;
begin
     raiz:=false;
     copyfile(arch,'@.@');
     Assign(btfd2,'@.@');
     fs:=filesize(btfd);
     Close(btfd);
     Erase(btfd);
     Reset(btfd2);
     pos:=filepos(btfd2);
     repeat
       inc(pos);
       read(btfd2,b);
       for i:=1 to maxkeys do
         if (not b.r[i].bor)and(b.r[i].key<>nokey) then
         begin
           If not raiz then
           begin
             key:=b.r[i];
             root:=createtree;
           end;
           raiz:=true;
           If raiz then
           begin
             root:=getroot;
             promoted:=insert(root,b.r[i],promorrn,promokey);
             If promoted then
               root:=createroot(promokey,root,promorrn);
           end
         end;
     until pos>=fs;
     close(btfd2);
     Erase(btfd2);
     close(btfd);
     if not raiz then
       Erase(btfd);
     Writeln;
     Writeln('El arbol ha sido actualizado');
     Writeln;
     Writeln('Presione cualquier tecla para continuar...');
     k:=readkey;
end;


Begin
     clrscr;
     Writeln('Dame el nombre del archivo');
     readln(arch);
     minkeys:=maxkeys div 2;
     pagesize:=sizeof(BTPage);
     Repeat
       If btopen then
         root:=getroot
       else
       begin
         Write('Dame la raiz: ');
         readln(key.key);
         root:=createtree;
       end;
       clrscr;
       Writeln('1)Insertar');
       Writeln('2)Buscar');
       Writeln('3)Borrar');
       Writeln('4)Desborrar');
       Writeln('5)Mostrar');
       Writeln('6)Mostrar borrados');
       Writeln('7)Eliminar');
       Writeln('8)Salida');
       repeat g:=readkey until g in ['1'..'8'];
       btopen;
       Case g of
         '1':insertar;
         '2':buscar;
         '3':borrar(true);
         '4':borrar(false);
         '5':mostrar(true);
         '6':mostrar(false);
         '7':eliminar;
       end;
     until g='8';

End.
